<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备名称" prop="deviceName">
        <el-input
          v-model="queryParams.deviceName"
          placeholder="请输入设备名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="设备编号" prop="deviceCode">
        <el-input
          v-model="queryParams.deviceCode"
          placeholder="请输入设备编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['baseInfo:device:add']"
        >新增</el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          v-hasPermi="['baseInfo:device:edit']"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          v-hasPermi="['baseInfo:device:remove']"
          @click="handleDelete"
        >删除</el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		      :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['baseInfo:device:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="设备名称" align="center" prop="deviceName" />
      <el-table-column label="设备类型" align="center" prop="deviceType" :formatter="deviceTypeFormatter"/>
      <el-table-column label="设备编号" align="center" prop="deviceCode" />
      <el-table-column label="具体地址" align="center" prop="deviceAddr" :show-overflow-tooltip="true"/>
      <el-table-column label="设备型号" align="center" prop="deviceModel" />
      <el-table-column label="设备图片" align="center" prop="iconUrl">
        <template slot-scope="scope">
          <el-image v-if="scope.row.iconUrl" :src="scope.row.iconUrl" :preview-src-list="[scope.row.iconUrl]" :z-index="9999" style="width: 30px;height: 30px;"></el-image>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="联系人" align="center" prop="linkman" />
      <el-table-column label="电话" align="center" prop="phone" width="120"/>
      <el-table-column label="安装时间" align="center" prop="installationTime" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.installationTime">{{ parseTime(scope.row.installationTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <!--<el-table-column label="最后巡检时间" align="center" prop="inspectionTime" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.inspectionTime">{{ parseTime(scope.row.inspectionTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="180">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
            v-hasPermi="['baseInfo:device:query']"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['baseInfo:device:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['baseInfo:device:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="设备名称" prop="deviceName">
              <el-input v-model="form.deviceName" placeholder="请输入设备名称" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="设备类型" prop="deviceType">
              <el-select
                v-model="form.deviceType"
                placeholder="请选择设备类型"
                style="width: 100%"
              >
                <el-option
                  v-for="deviceType in deviceTypeList"
                  :key="deviceType.dictValue"
                  :label="deviceType.dictLabel"
                  :value="deviceType.dictValue"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12">
            <el-form-item label="设备编号" prop="deviceCode">
              <el-input v-model="form.deviceCode" placeholder="请输入设备编号" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="设备型号" prop="deviceModel">
              <el-input v-model="form.deviceModel" placeholder="请输入设备型号" />
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="24">
            <el-form-item label="具体地址" prop="deviceAddr">
              <el-input v-model="form.deviceAddr" placeholder="请输入具体地址" />
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="24">
            <el-form-item label="经纬度坐标" prop="longitude">
              <el-col :span="8">
                <el-input v-model="form.longitude" placeholder="请输入经度"/>
              </el-col>
              <el-col :span="8" style="margin-left: 20px">
                <el-input v-model="form.latitude" placeholder="请输入纬度"/>
              </el-col>
              <el-col :span="4" style="margin-left: 30px">
                <el-button type="primary" plain @click="MapdialogFun">选择经纬度</el-button>
              </el-col>
            </el-form-item>
          </el-col>
        </el-row>

        <el-form-item label="设备图片" prop="iconUrl">
          <ImageUpload v-model="form.iconUrl"/>
        </el-form-item>

        <el-row>
          <el-col :span="12">
            <el-form-item label="联系人" prop="linkman">
              <el-input v-model="form.linkman" placeholder="请输入联系人" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="电话" prop="phone">
              <el-input v-model="form.phone" maxlength="11" placeholder="请输入电话" />
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12">
            <el-form-item label="安装时间" prop="installationTime">
              <el-date-picker clearable size="small"
                              v-model="form.installationTime"
                              type="datetime"
                              value-format="yyyy-MM-dd HH:mm:ss"
                              placeholder="选择安装时间">
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <GetPos
      :dialogVisible.sync="dialogTableVisibles"
      :devicePos="devicePos"
      @close="dialogcancelFun"
      @getPath="getPath"
      style="z-index: 3000"
      ref="getPos"
    />

    <DetailInfo ref="detail"/>
  </div>
</template>

<script>
import { listInfo, getInfo, delInfo, addInfo, updateInfo, exportInfo } from "@/api/baseinfo/deviceInfo";
import GetPos from '@/components/GetPos';
import ImageUpload from "@/components/ImageUpload";
import DetailInfo from "./components/DetailInfo"
import { mapDotList } from "@/api/devicemanage/mapdot";
import ReferPointInfo from "../pipeinfo/components/ReferPointInfo";
export default {
  name: "Info",
  components: {
    GetPos,
    ImageUpload,
    DetailInfo,
    ReferPointInfo
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备信息表格数据
      infoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        deviceName: null,
        deviceCode: null,
        deviceAddr: null,
        deviceModel: null,
        deviceType: null,
        beyondEnterpriseId: null,
        beyondEnterpriseName: null,
        longitude: null,
        latitude: null,
        iconUrl: null,
        linkman: null,
        phone: null,
        installationTime: null,
        inspectionTime: null,
        isDel: null,
        remarks: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        deviceName: [
          { required: true, message: "设备名称不能为空", trigger: "blur" }
        ],
        deviceType: [
          { required: true, message: "请选择设备类型", trigger: "blur" }
        ],
        deviceCode: [
          { required: true, message: "设备编号不能为空", trigger: "blur" }
        ],
        deviceAddr: [
          { required: true, message: "所在地不能为空", trigger: "blur" }
        ],
        longitude: [
          { required: true, message: "经纬度不能为空", trigger: "blur" }
        ],
        linkman: [
          { required: true, message: "联系人不能为空", trigger: "blur" }
        ],
        phone: [
          { required: true, message: "电话不能为空", trigger: "blur" },
          {
            type: 'number',
            message: '手机号格式不正确',
            trigger: 'blur',
            transform(value) {
              let phonereg = 11 && /^((13|14|15|16|17|18|19)[0-9]{1}\d{8})$/
              if (!phonereg.test(value)) {
                return false
              } else {
                return Number(value)
              }
            }
          }
        ],
        installationTime:[
          { required: true, message: "请选择安装时间", trigger: "change" },
        ]
      },
      dialogTableVisibles: false,
      devicePos: [],
      detailOpen: false,
      deviceNames: [],
      deviceTypeList: [],
      referPointData: [],
      referMarkerList: [],
      deviceType:{
        1 : "调压箱",
        2 : "阀门井",
        3 : "管线",
        4 : "管线定向钻",
        5 : "管线大开挖",
        6 : "管线直埋",
        7 : "阴保测试桩",
        8 : "光缆测试桩",
        9 : "排流测试桩",
        10 : "计量柜",
        11 : "交叉测试桩",
      },
    };
  },
  created() {
    this.getList();
    this.getDicts("t_device_type").then(res =>{
      this.deviceTypeList = res.data;
    })
  },
  methods: {
    /** 查询设备信息列表 */
    getList() {
      this.loading = true;
      listInfo(this.queryParams).then(response => {
        this.infoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        deviceId: null,
        deviceName: null,
        deviceCode: null,
        deviceAddr: null,
        deviceModel: null,
        deviceType: null,
        beyondEnterpriseId: null,
        beyondEnterpriseName: null,
        longitude: null,
        latitude: null,
        iconUrl: null,
        linkman: null,
        phone: null,
        installationTime: null,
        inspectionTime: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        isDel: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.deviceId);
      this.deviceNames = selection.map(item => item.deviceName);
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加设备信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const deviceId = row.deviceId || this.ids
      getInfo(deviceId).then(response => {
        this.form = response.data;
        if(this.form.longitude){
          this.devicePos = [this.form.longitude,this.form.latitude];
        }
        this.open = true;
        this.title = "修改设备信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.deviceId != null) {
            updateInfo(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            //this.form.deviceType = '1';
            addInfo(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const deviceIds = row.deviceId || this.ids;
      const deviceNames = row.deviceName || this.deviceNames;
      this.$confirm('是否确认删除设备信息名称为"' + deviceNames + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfo(deviceIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有设备信息数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfo(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    /**
     * 地图关闭方法
     */
    dialogcancelFun() {
      this.dialogTableVisibles = false;
    },
    /**
     * 经纬度 选择
     * @param res
     */
    getPath(res){
      //确认选择经纬度
      this.form.longitude = res[0];
      this.form.latitude = res[1];
    },
    /**
     * 经纬度坐标方法
     */
    MapdialogFun() {
      this.dialogTableVisibles = true;
      this.clearReferMarker();
      this.getReferPointInfo();
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.deviceId);
    },
    deviceTypeFormatter(row){
      return this.selectDictLabel(this.deviceTypeList,row.deviceType);
    },
    //初始化参照点
    initReferMarker(){
      this.referPointData.forEach(item =>{
        if(item.type == '1'){
          this.addReferMarker("https://yhq.zhkjgf.com:8898/profile/upload/2024/01/18/901a4dd9-0fd5-42ab-8b0e-db016808e676.png",item);
        }
        if(item.type == '2'){
          this.addReferMarker("https://yhq.zhkjgf.com:8898/profile/upload/2024/01/18/8af41515-c335-47dc-a24e-c181d8129947.png",item);
        }
      })
    },
    //获取参照点
    getReferPointInfo(){
      mapDotList().then(res =>{
        if(res.code == 200){
        this.referPointData = res.data;
        this.initReferMarker();
      }
    })
    },
    addReferMarker(icon,data){
      let marker = new AMap.Marker({
        map: this.$refs.getPos.map.map,
        anchor: "bottom-center",
        icon,
        position: [data.longitude, data.latitude],
        label: {
          content: "<div style='margin-bottom: 3px'>设备类型:&nbsp;" + this.deviceType[data.type] + "</div><div>设备名称:&nbsp;" + data.title + "</div>",
          direction: 'top',
        },
        extData: data,
      });
      this.referMarkerList.push(marker);
      this.clickEvent(marker,data);
    },
    clearReferMarker(){
      this.referMarkerList?.forEach((iten) => {
          this.$refs.getPos.map.map.remove(iten);
      });
      this.referMarkerList = [];
    },
    clickEvent(marker,data){
      marker.on("mouseover", (e) => {
        let referPoint = this.createReferPointInfoWindow(data);
        this.infowindow = new AMap.InfoWindow({
          isCustom: true,
          content: referPoint.$el,
          position: [data.longitude, data.latitude],
          // anchor: "top-left",
          // offset: [20, -15],
          anchor: "middle-left",
          offset: [20, 0],
        });
        this.infowindow.open(this.$refs.getPos.map.map);
      });
      marker.on("mouseout", (e) => {this.infowindow.close()});
    },
    //创建点弹框
    createReferPointInfoWindow(data){
      let that = this;
      let ReferPoint = this.$Vue.extend(ReferPointInfo,{});
      return new ReferPoint({
        data(){
          return{
            parent: that,
            pointInfo: data
          }
        }
      }).$mount();
    },
  }
};
</script>
